%{?scl:%scl_package antlr4}
%{!?scl:%global pkg_name %{name}}

#%{?_with_bootstrap: %global bootstrap 1}
%global bootstrap 1

Name:		%{?scl_prefix}antlr4
Version:	4.5.2
Release:	2%{?dist}
Summary:	Java parser generator
# C# runtime is MIT-licensed, but currently it is not used in this package
License:	BSD
URL:		http://www.antlr.org/
BuildArch:	noarch

Source0:	https://github.com/antlr/%{pkg_name}/archive/%{version}.tar.gz#/%{pkg_name}-%{version}.tar.gz

%if 0%{?bootstrap}
# generate with:
# mock -i antlr4-maven-plugin
# (cd `mock -p` && tar cjf $OLDPWD/antlr4-prebuilt.tar.bz2 usr/share/{maven-metadata,java}/antlr4*)
Source9999:	%{pkg_name}-prebuilt.tar.bz2
%endif

BuildRequires:	%{?scl_prefix_maven}maven-local
BuildRequires:	%{?scl_prefix_maven}maven-plugin-bundle
BuildRequires:  %{?scl_prefix_maven}maven-project
BuildRequires:	%{?scl_prefix_maven}maven-plugin-plugin
BuildRequires:	%{?scl_prefix_maven}maven-plugin-annotations
BuildRequires:	%{?scl_prefix_maven}plexus-compiler
BuildRequires:	%{?scl_prefix_maven}sonatype-oss-parent
BuildRequires:	%{?scl_prefix_maven}plexus-build-api
BuildRequires:	%{?scl_prefix}antlr3-tool
BuildRequires:	%{?scl_prefix}antlr3-java
BuildRequires:	%{?scl_prefix}treelayout
BuildRequires:	%{?scl_prefix}stringtemplate
BuildRequires:	%{?scl_prefix}stringtemplate4
#BuildRequires:	mvn(org.apache.maven:maven-plugin-api)
%{?scl:Requires: %scl_runtime}

%if ! 0%{?bootstrap}
BuildRequires:	%{?scl_prefix}%{pkg_name}
BuildRequires:	%{?scl_prefix}%{pkg_name}-runtime
BuildRequires:	%{?scl_prefix}%{pkg_name}-maven-plugin
%endif

%description
ANTLR (ANother Tool for Language Recognition) is a powerful parser
generator for reading, processing, executing, or translating
structured text or binary files.  It's widely used to build languages,
tools, and frameworks. From a grammar, ANTLR generates a parser that
can build and walk parse trees.

%package runtime
Summary:	ANTLR runtime

%description runtime
This package provides runtime library used by parsers generated by
ANTLR.

%package maven-plugin
Summary:	ANTLR plugin for Apache Maven

%description maven-plugin
This package provides plugin for Apache Maven which can be used to
generate ANTLR parsers during build.

%package javadoc
Summary:	API documentation for %{name}

%description javadoc
This package contains %{summary}.

%prep
%setup -q -n %{pkg_name}-%{version}
find -name \*.jar -delete

%if 0%{?bootstrap}
mkdir bootstrap-repo
tar xf %{SOURCE9999} -C bootstrap-repo
sed -i "s:/usr/share/:$PWD/bootstrap-repo&:g" bootstrap-repo/usr/share/maven-metadata/*.xml
sed -i "/optional/d" bootstrap-repo/usr/share/maven-metadata/*.xml
mkdir -p .xmvn/config.d
cat > .xmvn/config.d/bootstrap-config.xml <<EOF
<configuration>
<resolverSettings>
  <metadataRepositories>
    <repository>$PWD/bootstrap-repo/usr/share/maven-metadata</repository>
  </metadataRepositories>
</resolverSettings>
</configuration>
EOF
%endif

%{?scl:scl enable %{scl_maven} %{scl} - << "EOF"}
# Missing test deps: org.seleniumhq.selenium:selenium-java
%pom_disable_module runtime-testsuite
%pom_disable_module tool-testsuite

# Don't bundle dependencies
%pom_remove_plugin :maven-shade-plugin tool

# On ARM builder
# Tests run: 3, Failures: 0, Errors: 1, Skipped: 1, Time elapsed: 32.898 sec <<< FAILURE!
# - in org.antlr.v4.test.tool.TestPerformance
# testExponentialInclude(org.antlr.v4.test.tool.TestPerformance)  Time elapsed: 20.027 sec  <<< ERROR!
# org.junit.runners.model.TestTimedOutException: test timed out after 20000 milliseconds
find -name TestPerformance.java -delete

%mvn_package :%{pkg_name}-master %{pkg_name}-runtime
%{?scl:EOF}

%build
%{?scl:scl enable %{scl_maven} %{scl} - << "EOF"}
%mvn_build -s -f
%{?scl:EOF}

%install
%{?scl:scl enable %{scl_maven} %{scl} - << "EOF"}
%mvn_install
%{?scl:EOF}

%jpackage_script org.antlr.v4.Tool "" "" %{pkg_name}/%{pkg_name}:antlr3-runtime:%{kg_name}/%{pkg_name}-runtime:stringtemplate4:treelayout %{pkg_name} true

%files -f .mfiles-%{pkg_name}
%{_bindir}/%{pkg_name}
%doc tool/MIGRATION.txt

%files runtime -f .mfiles-%{pkg_name}-runtime
%doc CHANGES.txt README.md
%license LICENSE.txt

%files maven-plugin -f .mfiles-%{pkg_name}-maven-plugin

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt

%changelog
* Wed Dec 07 2016 Tomas Repik <trepik@redhat.com>
- scl conversion

* Tue Feb 16 2016 Mikolaj Izdebski <mizdebsk@redhat.com> - 4.5.2-1
- Update to upstream version 4.5.2

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 4.5.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Nov 27 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 4.5.1-2
- Use upstream POMs for buliding

* Fri Nov 27 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 4.5.1-1
- Update to upstream version 4.5.1

* Tue Jun 16 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue Mar 31 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 4.5-3
- Non-bootstrap build

* Mon Mar 30 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 4.5-2
- Post-review cleanup

* Thu Mar 26 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 4.5-1
- Initial packaging
